<?php

/**
 * Resource example class
 */
require_once('src/resources/IServerResource.interface.php');


class Resource implements IServerResource {

    private $DB_HOST = '******';
    private $DB_USER = '******';
    private $DB_PASS = '******';
    private $DB_NAME = '******';

    /**
     * Function that gets the resource requested by the scope
     * TODO
     * @param <String> $scope
     * @param <Array> $extra Extra parameters
     * @return string Resource
     */
    protected $header;

    /**
     * Function that gets the resource specified with the scope.
     * @param <type> $scope
     * @return <type> the resource
     */
    public function getResource($scope, $extra=null) {
        $sHO = $this->getsHO($extra);
        $ididp = $this->sHO2Ididp($sHO);
        return $this->script($ididp);
    }

    private function getsHO($extra){
        $sho="ididp";
        if(array_key_exists("sHO",$extra)){
            $sho = $extra["sHO"];
        }
        return $sho;
    }

    private function sHO2Ididp($sho) {
        $ididp = null;
        $xml_string = $this->curlConnect("http://www.rediris.es/sir/api/idps_available.php");
        $xml = new SimpleXMLElement($xml_string);
        foreach ($xml->IdentityProvider as $idp) {
            foreach ($idp->Scopes as $scope) {
                $attrs = $scope->Scope->attributes();
                if (strcmp($sho, $attrs['value']) == 0) {
                    $aux = $idp->PAPI_ID->attributes();
                    $ididp = $aux['value'];
                }
            }
        }
        return $ididp;
    }

    /**
     * Function that checks if the scope is available for the person_id
     * TODO
     * @param <type> $scope
     * @param <type> $person_id
     * @return <type>
     */
    public function checkScope($scope, $person_id=null) {
        return true;
    }

    public function hasHeader() {
        $dev = false;
        if (null != $this->header) {
            $dev = true;
        }
        return $dev;
    }

    public function getHeader() {
        return $this->header;
    }

    /**
     * Function that makes a get curl connection to an specified url.
     * @param <type> $url
     * @return <type>  output of the connection
     */
    private function curlConnect($url) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $output = curl_exec($ch);
        if (curl_errno($ch)) {
            return( 'Getting Resource Error' . curl_error($ch) );
        }
        $info = curl_getinfo($ch);
        if ($info['http_code'] != 200) {
            return( 'Getting Resource Error' . $output);
        }
        curl_close($ch);
        return $output;
    }

    private function orderByName($a, $b) {
        $res = strcmp($a["category"], $b["category"]);
        if ($res > 0) {
            return 1;
        } else if ($res < 0) {
            return -1;
        } else {
            $res = strcmp($a["name"], $b["name"]);
            if ($res > 0) {
                return 1;
            } else if ($res < 0) {
                return -1;
            }
        }
        return $res;
    }

    private function script($ididp) {
        header('Content-Type: text/xml; charset=utf-8');
        $content = "<Response>";
        if (null == $ididp || $ididp == "") {
            $content .= "<Error />";
        } else {
            $search_spid = '';
            $search_prot = '';
            $search_cat = '';
            $lang = 'es';
            $res = array();
            $link = mysql_connect($this->DB_HOST, $this->DB_USER, $this->DB_PASS);
            if (!@mysql_select_db($this->DB_NAME, $link)) {
                $content .= "ERROR: no BBDD";
                exit;
            }
            if (array_key_exists("lang", $_REQUEST)) {
                $lang = mysql_real_escape_string($_REQUEST["lang"]);
            }
            if (array_key_exists("idsp", $_REQUEST)) {
                $search_spid = mysql_real_escape_string($_REQUEST["idsp"]);
            }
            if (array_key_exists("prot", $_REQUEST)) {
                $search_prot = mysql_real_escape_string($_REQUEST["prot"]);
            }
            if (array_key_exists("category", $_REQUEST)) {
                $search_cat = mysql_real_escape_string($_REQUEST["category"]);
            }
            $id_idp_papi = mysql_real_escape_string($ididp);
            $found = false;
            $query = sprintf("SELECT * FROM SIR_IDP WHERE IdAS='%s';",
                            $id_idp_papi);
            $result = @mysql_query($query, $link);
            while ($arr = @mysql_fetch_array($result)) {
                $found = true;
                $id_idp = $arr["Id"];
            }
            if ($found == false) {
                $content .= "<Error />";
            } else {

                $where = true;
                $query = "SELECT * FROM SIR_SP";
                if (strcmp($search_spid, "") != 0 || strcmp($search_prot, "") != 0) {
                    $query .= " WHERE";
                }
                if (strcmp($search_prot, "") != 0) {
                    if ($where == false) {
                        $query .= " AND";
                    }
                    $query .= " Protocol='" . $search_prot . "'";
                    $where = false;
                }
                if (strcmp($search_spid, "") != 0) {
                    if ($where == false) {
                        $query .= " AND";
                    }
                    $query .= " Id='" . $search_spid . "'";
                    $where = false;
                }
                if (strcmp($search_cat, "") != 0) {
                    if ($where == false) {
                        $query .= " AND";
                    }
                    $query .= " Category='" . $search_cat . "'";
                    $where = false;
                }
                $result = @mysql_query($query, $link);
                while ($arr = @mysql_fetch_array($result)) {
                    $access = true;
                    $private = $arr["RestrictedAccess"];
                    if ($private == 1) {
                        $access = false;
                        $query2 = "SELECT * FROM SIR_ACCESS WHERE IdPId='" . $id_idp . "' AND SPId='" . $arr["Id"] . "';";
                        $result2 = @mysql_query($query2, $link);
                        if ($arr2 = @mysql_fetch_array($result2)) {
                            $access = strcmp($arr2["State"], "1") == 0;
                        }
                    }
                    if ($access == true) {
                        $data = array("id" => $arr["Id"],
                            "protocol" => $arr["Protocol"],
                            "name" => utf8_encode($arr["Name"]),
                            "idp_first_url" => $arr["IdPFirstURL"],
                            "category" => $arr["Category"],
                            "tech_info_url" => $arr["TechInfoURL"],
                            "access_url" => $arr["AccessURL"]);
                        $query2 = sprintf("SELECT * FROM SIR_SP_Description WHERE IdSP='" . $arr["Id"] . "' AND Lang='%s';",
                                        $lang);
                        $result2 = @mysql_query($query2, $link);
                        while ($arr2 = @mysql_fetch_array($result2)) {
                            $data["description"] = utf8_encode($arr2["Description"]);
                            if (strcmp($arr2["VideoHelp"], "") != 0) {
                                $data["videohelp"] = utf8_encode($arr2["VideoHelp"]);
                            }
                        }
                        $res[] = $data;
                    }
                }
                usort($res, array("Resource","orderByName"));
                foreach ($res as $sp) {
                    $content .= "<ServiceProvider id='" . $sp["id"] . "' protocol='" . $sp['protocol'] . "' category='" . $sp['category'] . "'>";
                    $content .= '	<Name><![CDATA[' . $sp["name"] . ']]></Name>';
                    $content .= '	<Description><![CDATA[' . $sp["description"] . ']]></Description>';
                    $content .= '  <URL><![CDATA[' . $sp["access_url"] . ']]></URL>';
                    $content .= '  <TechnicalInfo><![CDATA[' . $sp["tech_info_url"] . ']]></TechnicalInfo>';
                    if (array_key_exists("idp_first_url", $sp) && strcmp($sp["idp_first_url"], "") != 0) {
                        $url_sp = "http://sir.rediris.es/idpfirst/?idpid=" . mysql_real_escape_string($id_idp) . "&spid=" . $sp["id"];
                        $content .= '	<Wayfless><![CDATA[' . $url_sp . ']]></Wayfless>';
                    }
                    if (array_key_exists("videohelp", $sp) && strcmp($sp["videohelp"], "") != 0) {
                        $content .= '	<VideoTutorial><![CDATA[' . $sp["videohelp"] . ']]></VideoTutorial>';
                    }
                    $content .= "</ServiceProvider>";
                }
            }
        }
        $content .= "</Response>";
        return $content;
    }

}
?>